-- author RivalBomb

claasLexion430 = {};

function claasLexion430.prerequisitesPresent(specializations)
	print("......LOADING CLAAS LEXION 400 by RIVALBOMB......");
    return SpecializationUtil.hasSpecialization(Motorized, specializations) and SpecializationUtil.hasSpecialization(Overloading, specializations);
end;

function claasLexion430:load(xmlFile)
	self.playerCallback = SpecializationUtil.callSpecializationsFunction("playerCallback");

	self.percentMaschine = 0;
	self.percent = 0;
	self.renderpercent = 0;
	self.timeSinceLastUpdate = 0;
	self.timeAtMaxLoad = 0;
	self.motorTorqueScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motor#torqueScale"), 1);
	self.loadActive = false;

	local width, height = getNormalizedScreenValues(333, 30);
	local w, h = getNormalizedScreenValues(0, 244);	
	self.loadBarWidth = width;	
	self.xPos = 1-width;
	self.yPos = h;
	self.loadBar = Overlay:new("load_bar", Utils.getFilename("Texturen/loadBar.dds", self.baseDirectory), self.xPos, self.yPos, width, height);
	self.loadBarBG = Overlay:new("load_barBG", Utils.getFilename("Texturen/loadBarBG.dds", self.baseDirectory), self.xPos, self.yPos, width, height);


	if self.isClient then
		local node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.unloadingSound#node"));
		self.unloadingSound = Utils.loadSample(xmlFile, {}, "vehicle.unloadingSound", nil, self.baseDirectory, node);
		local node2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.strawChopperSound#node"));
		self.strawChopperSound = Utils.loadSample(xmlFile, {}, "vehicle.strawChopperSound", nil, self.baseDirectory, node2);
		local node3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.maizeChopperSound#node"));
		self.maizeChopperSound = Utils.loadSample(xmlFile, {}, "vehicle.maizeChopperSound", nil, self.baseDirectory, node3);
	end;
	
	-- Stroh-Haufen
	self.strawBunch = {};
	
	local i = 0;
	while true do
		local key = string.format("vehicle.strawBunches.strawBunch(%d)",i);
		if not hasXMLProperty(xmlFile, key) then
			break;
		end;

		local nodeWheat = getXMLString(xmlFile, key.. "#indexWheatBarley");
		local nodeRape = getXMLString(xmlFile, key.. "#indexRape");
		local nodeMaize = getXMLString(xmlFile, key.. "#indexMaize");
		local scaleNode = getXMLString(xmlFile, key.. "#scaleNode");
		if nodeWheat == nil or nodeRape == nil or nodeMaize == nil or scaleNode == nil then
			break;
		end;
		local trigger = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "#trigger"));
		if trigger == nil then
			break;
		end;

		i = i + 1;
		self.strawBunch[i] = {};
		self.strawBunch[i].scaleNode = Utils.indexToObject(self.components, scaleNode);
		self.strawBunch[i].indexWheat = Utils.indexToObject(self.components, nodeWheat);
		self.strawBunch[i].indexRape = Utils.indexToObject(self.components, nodeRape);
		self.strawBunch[i].indexMaize = Utils.indexToObject(self.components, nodeMaize);
		self.strawBunch[i].maxScale = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#maxScale"), 1);
		self.strawBunch[i].resetOnChopperSwitch = Utils.getNoNil(getXMLBool(xmlFile, key .. "#resetOnChopperSwitch"), false);
		self.strawBunch[i].curTrans = 0;
		self.strawBunch[i].trigger = trigger;
		self.strawBunch[i].plIR = false;
		setVisibility(self.strawBunch[i].indexWheat, false);
		setVisibility(self.strawBunch[i].indexRape, false);
		setVisibility(self.strawBunch[i].indexMaize, false);
		
		addTrigger( trigger, "playerCallback", self );
	end;
	self.fillLevelDeltas = {};
	self.lastFillLevelDelta = 0;

	self.currentStep = 1;
	
	self.timeSinceLastLoad = 0;
	
	self.threshingStartPS = {};
	Utils.loadParticleSystem(xmlFile, self.threshingStartPS, "vehicle.threshingStartParticleSystem", self.components, false, nil, self.baseDirectory);
	self.threshingStartPSoffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.threshingStartParticleSystem#startOffset"),0.1)*1000;
	self.threshingStartPStimer = 0;
	
	self.interiorLight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.interiorLight#index"));
	self.interiorLightActive = false;
	
	self.gearboxActive = false;	-- set this to true if you want to drive with gearbox script
	self.driveMode = false;
	self.driveModeAnalog = false;
	self.driveModeFactor = 0.01;
	self.driveModeRange = 500;
	self.driveModeGear = 0.5;
	self.driveModeNeutral = true;
	self.driveModeIsRevActive = false;
end;
function claasLexion430:delete()
	if self.unloadingSound ~= nil then
		Utils.deleteSample(self.unloadingSound);
	end;
	if self.strawChopperSound ~= nil then
		Utils.deleteSample(self.strawChopperSound);
	end;
	if self.maizeChopperSound ~= nil then
		Utils.deleteSample(self.maizeChopperSound);
	end;
	for i,j in pairs(self.strawBunch) do
		if j.trigger ~= nil then
			removeTrigger(j.trigger);
		end;
	end;
	Utils.deleteParticleSystem(self.threshingStartPS);
end;
function claasLexion430:readStream(streamId, connection)
	for i=1, #self.strawBunch do
		self.strawBunch[i].curTrans = streamReadFloat32(streamId);
	end;
end;
function claasLexion430:writeStream(streamId, connection)
	for i=1, #self.strawBunch do
		streamWriteFloat32(streamId, self.strawBunch[i].curTrans);
	end;
end;
function claasLexion430:mouseEvent(posX, posY, isDown, isUp, button)
end;
function claasLexion430:keyEvent(unicode, sym, modifier, isDown)
end;
function claasLexion430:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		for i,j in pairs(self.strawBunch) do
			local s = Utils.getNoNil( getXMLFloat(xmlFile, key..string.format("#strawBunchScale%d",i) ), 0);
			self.strawBunch[i].curTrans = s;
		end;
		self.driveMode = Utils.getNoNil(getXMLBool(xmlFile, key.."#specialDriveMode"), false);
	end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function claasLexion430:getSaveAttributesAndNodes(nodeIdent)
    local attributes = '';
	for i,j in pairs(self.strawBunch) do
		attributes = attributes .. string.format('strawBunchScale%d="%s" ', i, tostring(j.curTrans));
	end;
	attributes = attributes .. string.format('specialDriveMode="%s" ', tostring(self.driveMode));
    return attributes, nil;
end;
function claasLexion430:update(dt)
	if self.isEntered and self:getIsActiveForInput(false) then
		if self.camIndex == 2 and InputBinding.hasEvent(InputBinding.resetCamRotCL430) then
			self.cameras[2].rotX = -25*(math.pi/180);
			self.cameras[2].rotY = math.pi;
			self.cameras[2].rotZ = 0;
		end;
	end;
    if self:getIsActive() then
        if self.isClient and self:getIsActiveForInput(false) and not self:hasInputConflictWithSelection() then
            if InputBinding.hasEvent(InputBinding.EMPTY_GRAIN2) then
                if self.hasPipe then
                    local nextState = self.targetPipeState+1;
                    if nextState > self.numPipeStates then
                        nextState = 1;
                    end;
                    if self:getIsPipeStateChangeAllowed(nextState) then
                        self:setPipeState(nextState);
                    elseif nextState ~= 1 and self:getIsPipeStateChangeAllowed(1) then
                        -- also try to close the pipe if other states are not allowed
                        self:setPipeState(1);
                    end
                else
                    self:setOverloadingActive(not self.isOverloadingActive);
                end;
            end;
			if self:canToggleLight() then
				if InputBinding.hasEvent(InputBinding.SWITCH_INT_LIGHT) then
					self.interiorLightActive = not self.interiorLightActive;
					playSample(g_currentMission.toggleLightsSound, 1, 1.0, 0);
					setVisibility(self.interiorLight, self.interiorLightActive);
				end;
			end;
			if self.gearboxActive then
				if InputBinding.hasEvent(InputBinding.SWITCH_DRIVEMODE) then
					self.driveMode = not self.driveMode;
				end;
				if InputBinding.hasEvent(InputBinding.DRIVEMODE_NEUTRAL) then
					self.driveModeNeutral = not self.driveModeNeutral;
				end;
				if (InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE) > 0.1 or InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE) > 0.1) then
					self.driveModeNeutral = true;
				end;
				if InputBinding.hasEvent(InputBinding.DRIVEMODE_REVERSER) then
					self.driveModeIsRevActive = not self.driveModeIsRevActive;
				end;
				if InputBinding.hasEvent(InputBinding.DRIVEMODE_RANGE) then
					if self.driveModeRange == 500 then
						self.driveModeRange = 280;
						self.driveModeGear = 1;
					else
						self.driveModeRange = 500;
						self.driveModeGear = 0.5;
					end;
				end;
			end;
        end;
		if self.isServer and self.driveMode and self.gearboxActive then
			if not self.driveModeNeutral then
				local axisForward = -InputBinding.getDigitalInputAxis(InputBinding.AXIS_CRUISE_CONTROL);
				if InputBinding.isAxisZero(axisForward) then
					axisForward = InputBinding.getAnalogInputAxis(InputBinding.DRIVE_FASTER_SLOWER);
				end;
				self.driveModeFactor = math.max(0.01, math.min(self.driveModeFactor-(axisForward/self.driveModeRange),self.driveModeGear));
				self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_ACTIVE);
				self.cruiseControl.speed = math.ceil(self.motor:getMaximumForwardSpeed()*3.6)*self.driveModeFactor;
			else	-- neutral
				self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_OFF);
				self.driveModeFactor = 0.01;
				self.cruiseControl.speed = math.ceil(self.motor:getMaximumForwardSpeed()*3.6)*self.driveModeFactor;
			end;
		end;

		for i=1, #self.strawBunch do
			if self.chopperPSenabled or self.strawPSenabled then
				if self.strawBunch[i].resetOnChopperSwitch then
					if not self.isStrawEnabled then
						self.strawBunch[i].curTrans = math.min(self.strawBunch[i].curTrans+0.000005, self.strawBunch[i].maxScale);
					end;
				else
					self.strawBunch[i].curTrans = math.min(self.strawBunch[i].curTrans+0.000005, self.strawBunch[i].maxScale);
				end;
			end;
			if self.isStrawEnabled and self.strawBunch[i].resetOnChopperSwitch then
				self.strawBunch[i].curTrans = 0;
			end;
			local filltypee = self.currentFillType;
			if self.currentFilltype == Fillable.FILLTYPE_UNKNOWN then
				filltypee = FruitUtils.fruitTypeToFillType[self.lastValidInputFruitType];
			end;
			if filltypee == Fillable.FILLTYPE_WHEAT or filltypee == Fillable.FILLTYPE_BARLEY then
				setVisibility(self.strawBunch[i].indexWheat, true);
			else
				setVisibility(self.strawBunch[i].indexWheat, false);
			end;
			if filltypee == Fillable.FILLTYPE_RAPE then
				setVisibility(self.strawBunch[i].indexRape, true);
			else
				setVisibility(self.strawBunch[i].indexRape, false);
			end;
			if filltypee == Fillable.FILLTYPE_MAIZE then
				setVisibility(self.strawBunch[i].indexMaize, true);
			else
				setVisibility(self.strawBunch[i].indexMaize, false);
			end;
		end;
		
		--if self:mrGbMGetIsOn() ~= nil then
		--	self.loadActive = not self:mrGbMGetIsOn();
		--end;
		if self:getIsTurnedOn() and self.isServer and self.loadActive then
            --if self.lastCuttersArea > 0 then
				--local cutterWidth = 1;
				--for cutter,implement in pairs(self.attachedCutters) do
				--	cutterWidth = cutter.sizeWidth;
				--end;
				--if (self.lastCuttersInputFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN) then
				--	self.percent = (cutterWidth/self.lastCuttersArea)*50*((1/self.motorTorqueScale)/1.33);
				--end;
				local delta = self.fillLevel - self.lastFillLevelDelta;
				
				if delta > 0 then
					self.timeSinceLastLoad = 0;
					table.insert(self.fillLevelDeltas, {fillLevel = self.fillLevel, t = self.time});
					
					if table.getn(self.fillLevelDeltas) == 6 then
						local newDelta = self.fillLevelDeltas[6].fillLevel - self.fillLevelDeltas[1].fillLevel;
						local newTime = self.fillLevelDeltas[6].t - self.fillLevelDeltas[1].t;
						normalizedDelta = newDelta/newTime*1000;
						local cutterWidth = 1;
						for cutter,implement in pairs(self.attachedCutters) do
							cutterWidth = cutter.sizeWidth;
						end;
						self.percent = normalizedDelta*((1/(self.motorTorqueScale*1.85))*(cutterWidth/1.5));
						
						self.fillLevelDeltas = {};
					end;
				else
					self.timeSinceLastLoad = self.timeSinceLastLoad + dt;
				end;
				if (self.timeSinceLastLoad > 800 and self.percent > 0) then
					self.percent = 0;
				end;
				
				self.time = self.time + dt;
				self.lastFillLevelDelta = self.fillLevel;
			--else
			--	self.percent = 0;
			--end;
			--if self.percent ~= 0 then
				if self.percentMaschine > self.percent then
					--self.percentMaschine = self.percentMaschine-0.015*dt;
					if self.lastAreaZeroTime > 250 then
						self.percentMaschine = self.percentMaschine-0.02*dt;
					else
						self.percentMaschine = self.percentMaschine-0.008*dt;
					end;
				end;
				if self.percentMaschine < self.percent then
					if self.percent-self.percentMaschine > 30 then
						self.percentMaschine = self.percentMaschine+0.04*dt;
					else
						self.percentMaschine = self.percentMaschine+0.01*dt;
					end;
				end;
			--else
			--end;
			if self.percentMaschine > 100 then
				self.percentMaschine = 100;
			elseif self.percentMaschine < 0 then
				self.percentMaschine = 0;
			end;
			if self.percentMaschine > 99 then
				for cutter,implement in pairs(self.attachedCutters) do
					cutter.speedLimit = 0;
				end;
				if self.isEntered then
					g_currentMission:showBlinkingWarning(g_i18n:getText("threshingIsOverloaded"), 1000);
				end;
			else
				for cutter,implement in pairs(self.attachedCutters) do
					cutter.speedLimit = 11;
				end;
			end;
		else
			self.percent = 0;
		end;
	else
		self.interiorLightActive = false;
		setVisibility(self.interiorLight, false);
	end;
	local plIR = false;
	local id = 0;
	for i,j in pairs(self.strawBunch) do
		if j.plIR then
			id = i;
			plIR = true;
			break;
		end;
	end;
	if plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("CLEAR_STRAW_BUNCH"), InputBinding.CLEAR_STRAW_BUNCH);
		if InputBinding.hasEvent(InputBinding.CLEAR_STRAW_BUNCH) then
			self.strawBunch[id].curTrans = 0;
		end;
	end;
	for i=1, #self.strawBunch do
		setScale(self.strawBunch[i].scaleNode, self.strawBunch[i].curTrans, self.strawBunch[i].curTrans, math.min(self.strawBunch[i].curTrans*2, self.strawBunch[i].maxScale));
	end;
	if self.isClient and self.unloadingSound.sound3D ~= nil then
		if self.pipeIsUnloading then
			if not self.unloadingSoundPlaying then
				setVisibility(self.unloadingSound.sound3D, true);
				self.unloadingSoundPlaying = true;
			end;
		else
			if self.unloadingSoundPlaying then
				setVisibility(self.unloadingSound.sound3D, false);
				self.unloadingSoundPlaying = false;
			end;
		end;
	end;
	if self.isClient and self.strawChopperSound.sound3D ~= nil and self.maizeChopperSound.sound3D ~= nil then
		if self.chopperPSenabled then
			if self.cameras[self.camIndex].isInside and self.isEntered then
				setVisibility(self.strawChopperSound.sound3D, false);
				setVisibility(self.maizeChopperSound.sound3D, false);
			else
				if self.lastValidFillType == Fillable.FILLTYPE_MAIZE then
					setVisibility(self.maizeChopperSound.sound3D, true);
				else
					setVisibility(self.strawChopperSound.sound3D, true);
				end;
			end;
		else
			setVisibility(self.strawChopperSound.sound3D, false);
			setVisibility(self.maizeChopperSound.sound3D, false);
		end;
	end;
end;
function claasLexion430:updateTick(dt)
	if self:getIsActive() then
		if self.timeSinceLastUpdate >= 400 then
			self.renderpercent = self.percentMaschine;
			self.timeSinceLastUpdate = 0;
		end;
		self.timeSinceLastUpdate = self.timeSinceLastUpdate+dt;
		if self.isClient then
			if Utils.isSamplePlaying(self.sampleThreshingStart) then
				if self.threshingStartPStimer >= self.threshingStartPSoffset then
					Utils.setEmittingState(self.threshingStartPS, true)
				else
					self.threshingStartPStimer = self.threshingStartPStimer+dt;
				end;
			else
				Utils.setEmittingState(self.threshingStartPS, false);
				self.threshingStartPStimer = 0;
			end;
		end;
		if self.isServer and self.driveMode and self.gearboxActive then
			if not self.driveModeNeutral then
				local axisForward = math.min(math.ceil(self.motor:getMaximumForwardSpeed()*3.6)*self.driveModeFactor,1);
				local acceleration = 0;
				if self.isMotorStarted and self.motorStartTime <= g_currentMission.time then
					acceleration = axisForward;
				end;
				if self.fuelFillLevel == 0 then
					acceleration = 0;
				end;
				if self.driveModeIsRevActive then
					WheelsUtil.updateWheelsPhysics(self, dt, self.lastSpeedReal, -acceleration, false, self.requiredDriveMode);
				else
					WheelsUtil.updateWheelsPhysics(self, dt, self.lastSpeedReal,  acceleration, false, self.requiredDriveMode);
				end;
			end;
		end;
	end;
end;
function claasLexion430:draw()
	if self:getIsActiveForInput(false) then
		g_currentMission:addHelpButtonText(g_i18n:getText("SWITCH_INT_LIGHT"), InputBinding.SWITCH_INT_LIGHT); 
		if self.driveMode and self.gearboxActive then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("SWITCH_DRIVEMODE"),g_i18n:getText("DRIVEMODE_SPECIAL")), InputBinding.SWITCH_DRIVEMODE);
			if self.driveModeGear < 1 then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("DRIVEMODE_RANGE"), 1), InputBinding.DRIVEMODE_RANGE);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("DRIVEMODE_RANGE"), 2), InputBinding.DRIVEMODE_RANGE);
			end;
			if self.driveModeIsRevActive then
				g_currentMission:addHelpButtonText(g_i18n:getText("DRIVEMODE_REV"), InputBinding.DRIVEMODE_REVERSER);
			else
				g_currentMission:addHelpButtonText(g_i18n:getText("DRIVEMODE_FOR"), InputBinding.DRIVEMODE_REVERSER);
			end;
			g_currentMission:addHelpButtonText(g_i18n:getText("DRIVEMODE_NEUTRAL"), InputBinding.DRIVEMODE_NEUTRAL);
		elseif not self.driveMode and self.gearboxActive then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("SWITCH_DRIVEMODE"),g_i18n:getText("DRIVEMODE_DEFAULT")), InputBinding.SWITCH_DRIVEMODE);
		end;
		if self:getIsTurnedOn() and self.loadActive then
			--setTextColor(red, green, 0.0, 1.0);
			--setTextColor(0.9, 0.9, 0.9, 1);
			--renderText(self.xPos, self.yPos, 0.02, string.format("Dreschwerkauslastung: %d%%", self.renderpercent));	-- 0.85, 0.45
			setTextColor(0.95, 0.95, 0.95, 1);
			setTextAlignment(RenderText.ALIGN_CENTER);
			renderText(self.xPos+(self.renderpercent/1250)+0.01, self.yPos+0.0055, 0.019, string.format("%d %%", self.renderpercent));
			
			local red = 1.0;
			local green = 1.0;
			if self.renderpercent < 50 then
				red = (self.renderpercent/48);
			elseif self.renderpercent > 50 then
				green = 2-(self.renderpercent/48);
			end;
			setOverlayColor(self.loadBar.overlayId, red, green, 0, 1)
			self.loadBar.width = self.loadBarWidth * (self.renderpercent/100);
			self.loadBar:render();
			self.loadBarBG:render();
		end;
	end;
end;
function claasLexion430:playerCallback(triggerId, otherId, onEnter, onLeave, onStay)
	local id = 0;
	for i,j in pairs(self.strawBunch) do
		if j.trigger == triggerId then
			id = i;
			break;
		end;
	end;
	
	if id ~= 0 then
		if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
			self.strawBunch[id].plIR = true;
		elseif onLeave then
			self.strawBunch[id].plIR = false;
		end;
	end
	
end;